const authString = "Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in=";
const clientID = 0;
const clientIDString = "msmsgs@msnmsgr.com";
const clientIDCode = "Q1P7W2E4J9R8U3S5";
const MSNPort = "1863";
const commandsWithoutTrID = new Array("QNG", "NLN", "FLN", "MSG", "GTC", "BLP", "LST", "CHL", "NOT");

function MSNObject() {
  // user-related
  this.passport = '';
  this.password = '';
  this.nickname = '';
  this.status = "HDN";
  this.GTC = "A";
  this.BLP = "AL";
  this.contactlist = {};
  this.sl = 0;
  this.unreadEmails = 0;

  // connection-related
  this.trID = 0;
  this.qng = true;
  this.challenge = '';

  this.__defineGetter__("platform", function() {
    return "win 4.00 i386";
  });
}

MSNObject.prototype.__proto__ = BaseConnection;

MSNObject.prototype.logon = function(name, pass, initstat) {
  this.passport = name;
  this.password = pass;
  this.status = initstat;
  this.connect("messenger.hotmail.com", MSNPort);
  this.sendData('VER ' + ++this.trID + ' MSNP8 CVR0\r\n', 60000);
  loginProgress(0, "loginDS");
}

MSNObject.prototype.logout = function() {
  if (this.isConnected == true) {
    this.sendData('OUT\r\n');
    this.disconnect();
  }
  if (this.httpSocket) {
    this.httpSocket.close();
    delete this.httpSocket;
  }
  clearTimeout(this.pinger);
  clearInterval(this.slUpdater);
  this.contactlist = {};
}

MSNObject.prototype.onProtocolMessageReceived = function(msg, payload) {
  if (commandsWithoutTrID.indexOf(msg[0]) == -1 && msg[1] == "0" && msg[0] != "ADD" && msg[0] != "REM") return;
  switch (msg[0]) {
    case "VER":
      this.sendData('CVR ' + ++this.trID + ' ' + getLocaleID() + ' ' + this.platform + ' MSNMSGR 5.0.0575 MSMSGS ' + this.passport + '\r\n', 60000);
      break;
    case "CVR":
      this.sendData('USR ' + ++this.trID + ' TWN I ' + this.passport + '\r\n', 60000);
      break;
    case "XFR":
      if (msg[2] == "NS") {
        this.disconnect();
        var host = msg[3].split(":");
        this.trID = 0;
        this.connect(host[0], host[1]);
        this.sendData('VER ' + ++this.trID + ' MSNP8 CVR0\r\n', 60000);
        loginProgress(20, "loginNS");
      }
      else if (msg[2] == "SB") {
        var host = msg[3].split(":");
        this.newSession.open(host[0], host[1], msg[5]);
        delete this.newSession;
      }
      break;
    case "USR":
      if (msg[3] == "S") {
        this.challenge = msg[4];
        this.kv = extractField(this.challenge, "kv");
        dump("Opening connection to Passport Nexus...\n");
        this.authPhase = 1;
        this.httpSocket = new HttpSocket("https://nexus.passport.com/rdr/pprdr.asp");
        this.httpSocket.sendRequest(this);
        loginProgress(40, "authenticating");
      }
      else if (msg[2] == "OK") {
        this.nickname = unescape(uniConvertTo(msg[4]));
        this.sendData('SYN ' + ++this.trID + ' 0' + '\r\n', 60000);
        this.ping();
        nicknameChanged(this.nickname);
        loginProgress(80, "gettingContacts");
      }
      break;
    case "SYN":
      if (msg[3] != "0") {
        this.contactsLeft = parseInt(msg[3]);
      }
      else {
        this.changeStatus(this.status);
        loginSuccessful();
      }
      break;
    case "GTC":
      this.GTC = msg[1];
      break;
    case "BLP":
      this.BLP = msg[1];
      break;
    case "LSG":
      // no groups support for now
      break;
    case "LST":
      this.contactlist[msg[1]] = new MSNContact(msg[1], unescape(uniConvertTo(msg[2])), "FLN", parseInt(msg[3]));
      var contact = this.contactlist[msg[1]];
      if ((contact.lists & 14) == 8) {
        if (this.GTC == "A" || this.BLP == "BL") {
          window.openDialog("chrome://msnmsgr/content/contactaddprompt.xul", "_blank", "chrome,resizable", contact.email, contact.nickname);
        }
        else {
          contact.lists += 2;
        }
      }
      else {
        if (this.isContactInList(contact.email, "FL") == true) {
          addContact(contact.email, contact.nickname, contact.status, this.isContactInList(contact.email, "BL"));
        }
      }
      this.contactsLeft--;
      if (this.contactsLeft == 0) {
        this.changeStatus(this.status);
        loginSuccessful();
        delete this.contactsLeft;
      }
      break;
    case "MSG":
      var msgParts = payload.split('\r\n\r\n');
      var headers = parseHeaders(msgParts[0]);
      switch (headers["content-type"]) {
        case "text/x-msmsgsprofile; charset=UTF-8":
          this.ipAddress = headers["clientip"];
          this.sid = headers["sid"];
          this.mspauth = headers["mspauth"];
          this.slUpdater = setInterval(function() { window.client.sl++; }, 1000);
          break;
        case "text/x-msmsgsinitialemailnotification; charset=UTF-8":
          var msgData = parseHeaders(msgParts[1]);
          this.unreadEmails = parseInt(msgData["inbox-unread"]);
          updateEmailItem(this.unreadEmails);
          break;
        case "text/x-msmsgsemailnotification; charset=UTF-8":
          var msgData = parseHeaders(msgParts[1]);
          this.unreadEmails++;
          updateEmailItem(this.unreadEmails);
          newEmailReceived(msgData["from"]);
          break;
        case "text/x-msmsgsactivemailnotification; charset=UTF-8":
          var msgData = parseHeaders(msgParts[1]);
          if (msgData["src-folder"] == "ACTIVE") {
            this.unreadEmails -= parseInt(msgData["message-delta"]);
            updateEmailItem(this.unreadEmails);
          }
          break;
      }
      break;
    case "ILN":
      var contact = this.contactlist[msg[3]];
      var contactBlocked = this.isContactInList(contact.email, "BL");
      var uniNickname = unescape(uniConvertTo(msg[4]));
      if (contact.nickname != uniNickname) {
        contact.nickname = uniNickname;
        this.sendData('REA ' + ++this.trID + ' ' + contact.email + ' ' + msg[4] + '\r\n');
      }
      contact.status = msg[2];
      addOnlineContact(contact.email, contact.nickname, contact.status, contactBlocked);
      break;
    case "NLN":
      var contact = this.contactlist[msg[2]];
      var uniNickname = unescape(uniConvertTo(msg[3]));
      var contactBlocked = this.isContactInList(contact.email, "BL");
      var changes = 0;
      if (contact.status == "FLN") {
        if (contact.nickname != uniNickname) {
          contact.nickname = uniNickname;
          changes++;
        }
        contact.status = msg[1];
        changes += 2;
        contactSignedIn(contact.email, contact.nickname, contact.status, contactBlocked);
      }
      else {
        if (contact.nickname != uniNickname) {
          contact.nickname = uniNickname;
          changes++;
        }
        if (contact.status != msg[1]) {
          contact.status = msg[1];
          changes += 2;
        }
        contactChanged(contact.email, contact.nickname, contact.status, contactBlocked, changes);
      }
      if ((changes & 1) == 1) {
        this.sendData('REA ' + ++this.trID + ' ' + contact.email + ' ' + msg[3] + '\r\n');
      }
      broadcastContactChange(contact.email, contact.nickname, contact.status);
      break;
    case "FLN":
      var contact = this.contactlist[msg[1]];
      if (contact.status != "FLN") {
        var contactBlocked = this.isContactInList(contact.email, "BL");
        contact.status = "FLN";
        contactSignedOff(contact.email, contactBlocked);
        broadcastContactChange(contact.email, contact.nickname, contact.status);
      }
      break;
    case "CHL":
      var md5 = hex_md5(msg[2] + clientIDCode);
      this.sendData('QRY ' + ++this.trID + ' ' + clientIDString + ' ' + md5.length + '\r\n' + md5, 60000);
      break;
    case "CHG":
      this.status = msg[2];
      statusChanged(this.status);
      break;
    case "REA":
      if (msg[3] == this.passport) {
        this.nickname = unescape(uniConvertTo(msg[4]));
        nicknameChanged(this.nickname);
      }
      break;
    case "ADD":
      if (msg[4] in this.contactlist == false) {
        this.contactlist[msg[4]] = new MSNContact(msg[4], unescape(uniConvertTo(msg[5])), "FLN", 0);
      }
      var contact = this.contactlist[msg[4]];
      contact.lists += this.getListNumber(msg[2]);
      if (msg[2] == "FL") {
        addContact(contact.email, contact.nickname, contact.status, this.isContactInList(contact.email, "BL"));
      }
      if (msg[2] == "RL" && (contact.lists & 14) == 8) {
        if (this.GTC == "A" || this.BLP == "BL") {
          window.openDialog("chrome://msnmsgr/content/contactaddprompt.xul", "_blank", "chrome,resizable", contact.email, contact.nickname);
        }
        else {
          contact.lists += 2;
        }
      }
      break;
    case "REM":
      var contact = this.contactlist[msg[4]];
      contact.lists -= this.getListNumber(msg[2]);
      if (msg[2] == "FL") {
        removeContact(contact.email);
      }
      break;
    case "RNG":
      var SB = msg[2].split(":");
      setupIncomingSession(msg[5], SB[0], SB[1], msg[4], msg[1]);
      break;
    case "URL":
      var login = this.passport.substr(0, this.passport.indexOf("@"));
      var sl = this.sl;
      var rru = msg[2];
      if (typeof(this.composeTo) != "undefined") {
        rru += "?mailto=1&to=" + this.composeTo;
        delete this.composeTo;
      }
      var creds = hex_md5(this.mspauth + sl + this.password);
      loginEmail(msg[3], login, this.passport, this.sid, this.kv, msg[4], sl, rru, this.mspauth, creds);
      break;
    case "205":
      showError("err_205");
      break;
    case "209":
      showError("err_209");
      break;
    case "210":
      showError("err_210");
      break;
    case "215":
      showError("err_215");
      break;
    case "500":
      loginFailed("err_500");
      break;
    case "540":
      loginFailed("err_540");
      break;
    case "601":
      loginFailed("err_601");
      break;
    case "800":
      showError("err_800");
      break;
    case "910":
      loginFailed("err_910_921");
      break;
    case "911":
      loginFailed("err_911");
      break;
    case "913":
      delete this.newSession;
      showError("err_913");
      break;
    case "921":
      loginFailed("err_910_921");
      break;
  }
}

MSNObject.prototype.onConnectionReset = function() {
  signOut();
}

MSNObject.prototype.onHttpDataAvailable = function(status) {
  if (this.authPhase == 1) {
    var loginServerURL = "https://" + extractField(this.httpSocket.getHeader("PassportURLs"), "DALogin");
    dump("Login Server URL received. Opening connection to Login Server...\n");
    delete this.httpSocket;
    this.authPhase = 2;
    this.httpSocket = new HttpSocket(loginServerURL);
    this.httpSocket.setHeader("Authorization", authString + escape(this.passport) + ",pwd=" + escape(this.password) + "," + this.challenge);
    this.httpSocket.sendRequest(this);
  }
  else {
    var ticket = extractField(this.httpSocket.getHeader("Authentication-Info"), "from-PP");
    ticket = ticket.substr(1, ticket.length - 2);
    delete this.httpSocket;
    delete this.authPhase;
    dump("Ticket received. Sending ticket to Notification Server...\n");
    this.sendData('USR ' + ++this.trID + ' TWN S ' + ticket + '\r\n', 60000);
    loginProgress(60, "sendingTicket");
  }
}

MSNObject.prototype.changeStatus = function(status) {
  this.sendData('CHG ' + ++this.trID + ' ' + status + ' ' + clientID + '\r\n', 15000);
}

MSNObject.prototype.changeNickname = function(nickname) {
  this.sendData('REA ' + ++this.trID + ' ' + this.passport + ' ' + escape(nickname) + '\r\n', 15000);
}

MSNObject.prototype.addContact = function(email, list) {
  var groupParam = '';
  if (list == "FL") {
    groupParam = " 0";
  }
  this.sendData('ADD ' + ++this.trID + ' ' + list + ' ' + email + ' ' + email + groupParam + '\r\n', 60000);
}

MSNObject.prototype.removeContact = function(email, list) {
  var groupParam = '';
  if (list == "FL") {
    groupParam = " 0";
  }
  this.sendData('REM ' + ++this.trID + ' ' + list + ' ' + email + groupParam + '\r\n', 60000);
}

MSNObject.prototype.getListNumber = function(list) {
  var listNumber;
  switch (list) {
    case "FL":
      listNumber = 1;
      break;
    case "AL":
      listNumber = 2;
      break;
    case "BL":
      listNumber = 4;
      break;
    case "RL":
      listNumber = 8;
      break;
  }
  return listNumber;
}

MSNObject.prototype.isContactInList = function(email, list) {
  var isInList = false;
  var listNumber = this.getListNumber(list);
  if ((this.contactlist[email].lists & listNumber) == listNumber) {
    isInList = true;
  }
  return isInList;
}

MSNObject.prototype.getContact = function(email) {
  var contact = null;
  if (email in this.contactlist == true) {
    contact = new MSNContact(email, this.contactlist[email].nickname, this.contactlist[email].status, 0);
  }
  return contact;
}

MSNObject.prototype.getOnlineContacts = function() {
  var onlineContacts = new Array();
  for (var email in this.contactlist) {
    var contact = this.contactlist[email];
    if (contact.status != "FLN" && this.isContactInList(contact.email, "BL") == false) {
      onlineContacts.push(new Array(contact.email, contact.nickname));
    }
  }
  return onlineContacts;
}

MSNObject.prototype.getContactStatus = function(email) {
  return this.contactlist[email].status;
}

MSNObject.prototype.getSession = function(session) {
  this.newSession = session;
  this.sendData('XFR ' + ++this.trID + ' SB\r\n', 60000);
}

MSNObject.prototype.requestEmailURL = function(inboxOrEmail) {
  var request;
  if (inboxOrEmail == "INBOX") {
    request = inboxOrEmail;
  }
  else {
    request = "COMPOSE";
    this.composeTo = inboxOrEmail;
  }
  this.sendData('URL ' + ++this.trID + ' ' + request + '\r\n');
}

MSNObject.prototype.ping = function() {
  client.sendData('PNG\r\n', 60000);
  this.pinger = setTimeout("window.client.ping()", 50000);
}

MSNObject.prototype.getIPAddress = function() {
  return this.ipAddress;
}

function extractField(fields, fieldkey) {
  var field = fields.substr(fields.search(fieldkey));
  return field.substr(fieldkey.length + 1, field.search(",") - (fieldkey.length + 1));
}